/*  include files  */

#include <stdio.h>
#include <Xm/FileSB.h>


/*  Functions defined in this program  */

void main();


/*  Global variables  */


/*-------------------------------------------------------------
**  main - Main logic for xmbutton
*/
void main (argc,argv)
unsigned int argc;
char **argv;
{
  Widget       toplevel;    /*  Shell widget         */
  Widget       fbox;        /*  File selection box   */
  Arg          args[10];    /*  arg list             */
  register     int n;       /*  arg count            */
  XtAppContext app_context; /*  application context  */

/*  Initialize the toolkit, create application context, open display, 
    and create a toplevel shell */
  toplevel = XtAppInitialize (&app_context, "Filselbox", NULL, 0, &argc,
                              argv, NULL, args, 0);

/*  Create the file selection box */
  n = 0;
  fbox = XmCreateFileSelectionBox (toplevel, "fbox", args, n); 
  
/*  Manage the selectionbox widget */
  XtManageChild (fbox);

/*  Realize widgets  */
  XtRealizeWidget (toplevel);

/*  Process events  */
  XtAppMainLoop (app_context);
}

