#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/BulletinB.h>

/***********************************************************************
 ***                             MAIN                                ***
 ***********************************************************************/
void main(argc, argv)
 unsigned int argc;
 char **argv;
{
 Widget toplevel, frame, flabel, bboard, pbutton;
 Arg args[10];
 int n;
 char *text = "Push Me";
 char *ftext = "framedemo";
 XmString frame_text, label_text;
 XtAppContext app_context;
     
/*
 * Initialize the toplevel shell widget
 */
 toplevel = XtAppInitialize(&app_context, "Framedemo", NULL, 0, &argc, argv,
                              NULL, args, 0);

/*
 * Create the Frame Widget
 */
 n = 0;
 frame = XmCreateFrame (toplevel, "frame", args, n);
 XtManageChild(frame);

/*
 * Set up compound string for the frame title
 */
 frame_text = XmStringCreateLtoR(ftext, XmFONTLIST_DEFAULT_TAG);
   
/*
 * Create a label widget for the frame title
 */
 n = 0;
 XtSetArg(args[n], XmNchildType, XmFRAME_TITLE_CHILD); n++;
 XtSetArg(args[n], XmNchildHorizontalAlignment, XmALIGNMENT_CENTER); n++;
 XtSetArg(args[n], XmNlabelString, frame_text); n++;
 flabel = XmCreateLabel(frame, "flabel",args, n);
 XtManageChild(flabel);
 XmStringFree (frame_text);

/*
 * Create the BulletinBoard Widget
 */
 n = 0;
 bboard = XmCreateBulletinBoard (frame, "bboard", args, n);
 XtManageChild(bboard);

/*
 * Set up compound string 
 */
 label_text = XmStringCreateLtoR(text, XmFONTLIST_DEFAULT_TAG);
   
/*
 * Create the pushbutton.
 */
 n = 0;
 XtSetArg(args[n], XmNlabelString, label_text); n++;
 pbutton = XmCreatePushButton(bboard, "pbutton", args, n);
 XtManageChild(pbutton);
 XmStringFree (label_text);

/*
 * Realize the toplevel widget, which displays all children
 */ 
 XtRealizeWidget(toplevel);

/*
 * Go into a loop and wait for input
 */
 XtAppMainLoop(app_context);
}
