#include <Xm/Frame.h>
#include <Xm/PushB.h>
#include <Xm/BulletinB.h>

/***********************************************************************
 ***                             MAIN                                ***
 ***********************************************************************/
void main(argc, argv)
  unsigned int argc;
  char **argv;
{
   Widget toplevel, frame, bboard, pbutton;
   Arg args[10];
   int n;
   char *text = "Push Me";
   XmString label_text;
   XtAppContext app_context;
     
/*
 * Initialize the toplevel shell widget
 */
   toplevel = XtAppInitialize(&app_context, "Frametest", NULL, 0, &argc, argv,
                              NULL, args, 0);

/*
 * Create the Frame Widget
 */
 n = 0;
 frame = XmCreateFrame (toplevel, "frame", args, n);
 XtManageChild(frame);

/*
 * Create the BulletinBoard Widget
 */
 n = 0;
 bboard = XmCreateBulletinBoard (frame, "bboard", args, n);
 XtManageChild(bboard);

/*
 * Set up compound string 
 */
   label_text = XmStringCreateLtoR(text, XmFONTLIST_DEFAULT_TAG);
   
/*
 * Create the pushbutton.
 */
 n = 0;
   XtSetArg(args[n], XmNlabelString, label_text); n++;
   pbutton = XmCreatePushButton(bboard, "pbutton", args, n);
   XtManageChild(pbutton);
   XmStringFree (label_text);

/*
 * Realize the toplevel widget, which displays all children
 */ 
   XtRealizeWidget(toplevel);

/*
 * Go into a loop and wait for input
 */
   XtAppMainLoop(app_context);
}
